clear;
addpath(genpath('src'))
% Get example image
f = im2double(imread('dragon.jpg'));
% Jump penalty (larger choice -> less segments)
gamma = 1.3;
% Perform affine-linear image partitioning
[u,partition,a,b,c] = affineLinearPartitioning(f,'gamma',gamma);
% u: piecewise affine-linear approximation of f
% partition: corresponding partition
% a,b,c: slopes and offset (in matrix origin) of the first order
% polynomials in each pixel

% Show results
mask = boundarymask(partition);
partition_img = labeloverlay(u,mask,'Transparency',0,'Colormap',[ 0 0 0]);
figure,
subplot(2,2,1),imshow(f),title('Input image')
subplot(2,2,2),imshow(u),title('Pcw. affine approximation')
subplot(2,2,3),imshow(label2rgb(partition,'jet')),title('Partitioning')
subplot(2,2,4),imshow(partition_img),title('Accented Edges')
